# TreeWidthSolver.jl

[![Stable](https://img.shields.io/badge/docs-stable-blue.svg)](https://ArrogantGao.github.io/TreeWidthSolver.jl/stable/)
[![Dev](https://img.shields.io/badge/docs-dev-blue.svg)](https://ArrogantGao.github.io/TreeWidthSolver.jl/dev/)
[![Build Status](https://github.com/ArrogantGao/TreeWidthSolver.jl/actions/workflows/CI.yml/badge.svg?branch=main)](https://github.com/ArrogantGao/TreeWidthSolver.jl/actions/workflows/CI.yml?query=branch%3Amain)
[![Coverage](https://codecov.io/gh/ArrogantGao/TreeWidthSolver.jl/branch/main/graph/badge.svg)](https://codecov.io/gh/ArrogantGao/TreeWidthSolver.jl)


`TreeWidthSolver.jl` is a Julia package for solving the minimal treewidth and the corresponding tree decomposition of graphs. Currently we implemented the Bouchitte-Todinca algorithm[^Bouchitté][^Korhonen], which is a dynamic programming algorithm for solving the exact minimal treewidth problem of graphs. This package is used as a bacakend of [OMEinsumContractionOrders.jl](https://github.com/TensorBFS/OMEinsumContractionOrders.jl) for finding the optimal tensor network contraction order.

For more details about this pacakage please see the [docs](https://ArrogantGao.github.io/TreeWidthSolver.jl/stable/), and please refer to this [blog](https://arrogantgao.github.io/blogs/treewidth/) for more about the algorithm we implemented.

<!-- References -->

[^Bouchitté]: Bouchitté, Vincent, and Ioan Todinca. “Treewidth and Minimum Fill-in: Grouping the Minimal Separators.” SIAM Journal on Computing 31, no. 1 (January 2001): 212–32. https://doi.org/10.1137/S0097539799359683
[^Korhonen]: Korhonen, Tuukka, Jeremias Berg, and Matti Järvisalo. “Solving Graph Problems via Potential Maximal Cliques: An Experimental Evaluation of the Bouchitté--Todinca Algorithm.” ACM Journal of Experimental Algorithmics 24 (December 17, 2019): 1–19. https://doi.org/10.1145/3301297.

using AbstractTrees

"""
    mutable struct DecompositionTreeNode{T}

A mutable struct representing a node in a tree decomposition.

# Fields
- `bag::Set{T}`: The bag of the node, which is a set of elements of type `T`.
- `parent::Union{DecompositionTreeNode{T}, Nothing}`: The parent node of the current node. It can be either a `DecompositionTreeNode{T}` or `Nothing` if the current node is the root.
- `children::Vector{DecompositionTreeNode{T}}`: The children nodes of the current node, stored in a vector.

"""
mutable struct DecompositionTreeNode{T}
    bag::Set{T}
    parent::Union{DecompositionTreeNode{T}, Nothing}
    children::Vector{DecompositionTreeNode{T}}

    function DecompositionTreeNode(bag::Set{T}, p = nothing, c = Vector{DecompositionTreeNode{T}}()) where T
        new{T}(bag, p, c)
    end
end

DecompositionTreeNode(bag::Vector{T}) where T = DecompositionTreeNode(Set(bag), nothing, Vector{DecompositionTreeNode{T}}())

Base.:(==)(n1::DecompositionTreeNode{T}, n2::DecompositionTreeNode{T}) where {T} = (n1.bag == n2.bag) && (n1.children == n2.children)

function add_child!(parent::DecompositionTreeNode{T}, bag::Union{Set{T}, Vector{T}}) where T
    node = DecompositionTreeNode(Set(bag), parent, Vector{DecompositionTreeNode{T}}())
    push!(parent.children, node)
    nothing
end

function AbstractTrees.children(node::DecompositionTreeNode{T}) where{T}
    return node.children
end

AbstractTrees.nodevalue(n::DecompositionTreeNode) = n.bag

AbstractTrees.ParentLinks(::Type{<:DecompositionTreeNode}) = StoredParents()
AbstractTrees.parent(n::DecompositionTreeNode) = n.parent

AbstractTrees.NodeType(::Type{<:DecompositionTreeNode{T}}) where {T} = HasNodeType()
AbstractTrees.nodetype(::Type{<:DecompositionTreeNode{T}}) where {T} = DecompositionTreeNode{T}
Base.show(io::IO, td::DecompositionTreeNode) = print_tree(io, td)

Base.copy(node::DecompositionTreeNode{T}) where T = DecompositionTreeNode(node.bag, node.parent, Vector{DecompositionTreeNode{T}}(copy.(node.children)))

isleaf(node::DecompositionTreeNode) = isempty(node.children)
function width(tree::DecompositionTreeNode)
    tw = length(tree.bag) - 1
    return isleaf(tree) ? tw : max(tw, maximum(width.(children(tree))))
end

struct EliminationOrder{T}
    order::Vector{Vector{T}} # elimination order of vertices, the first element is the first one to be eliminated. The vertices in the same vector are eliminated at the same time.
end

# Generate an elimination order from a tree decomposition
EliminationOrder(tree::DecompositionTreeNode{T}) where{T} = _elimination_order(tree)

function _elimination_order(tree::DecompositionTreeNode{T}) where{T}
    order = Vector{Vector{T}}()

    for node in PostOrderDFS(tree)
        parent = node.parent
        temp = Vector{T}()
        for v in node.bag
            if (isnothing(parent) || (!isnothing(parent) && !(v in parent.bag)))
                pushfirst!(temp, v)
            end
        end
        !isempty(temp) && pushfirst!(order, temp)
    end

    return EliminationOrder(order)
end


# TreeDecomposition is a structure to store a treewidth and tree decomposition of a graph
"""
    struct TreeDecomposition{TW, TL}

A struct representing a tree decomposition.

# Fields
- `tw::TW`: The treewidth of the decomposition.
- `tree::DecompositionTreeNode{TL}`: The root node of the decomposition tree.

"""
struct TreeDecomposition{TW, TL}
    tw::TW
    tree::DecompositionTreeNode{TL}
end

function Base.show(io::IO, td::TreeDecomposition)
    print(io, "tree width: $(td.tw)\n", "tree decomposition:\n$(td.tree)")
end

function is_treedecomposition(G::SimpleGraph{TG}, td::TreeDecomposition{TW, TL}) where{TG, TW, TL}
    return is_treedecomposition(G, td.tree)
end

function is_treedecomposition(G::SimpleGraph{TG}, tree::DecompositionTreeNode{TL}) where{TG, TL}
    treebags = [node.bag for node in collect(PreOrderDFS(tree))]

    # all vertices in G are in some bag
    if Set(foldr(∪, collect.(treebags))) != Set(vertices(G))
        return false
    end

    # all edges in G are in some bag
    for edge in edges(G)
        i, j = src(edge), dst(edge)
        flag = false
        for Ω in treebags
            if (i in Ω && j in Ω)
                flag = true
            end
        end
        if !flag
            return false
        end
    end

    # all treebags containing the same vertex form a connected subtree
    eo = vcat(EliminationOrder(tree).order...)
    if (length(eo) != nv(G)) || (unique(eo) != eo)
        return false
    end

    return true
end

function tree_labeling(tree::DecompositionTreeNode{T}, labels::Vector{TL}) where{T, TL}
    new_tree = DecompositionTreeNode(Set{TL}(), nothing, Vector{DecompositionTreeNode{TL}}())
    _tree_labeling!(new_tree, tree, labels)
    return new_tree
end

function _tree_labeling!(new_tree::DecompositionTreeNode{TL}, tree::DecompositionTreeNode{T}, labels::Vector{TL}) where{T, TL}
    new_tree.bag = Set(labels[collect(tree.bag)])
    for child in children(tree)
        add_child!(new_tree, Set(labels[collect(child.bag)]))
        _tree_labeling!(new_tree.children[end], child, labels)
    end
    return nothing
end

function order2tree(eo::Vector{Int}, g::SimpleGraph{TG}) where {TG}
    bags, tree = _tree_bags(eo, g)
    nb = length(bags)
    d_tree = DecompositionTreeNode(Set(bags[nb]), nothing, Vector{DecompositionTreeNode{Int}}())
    return construct_tree!(d_tree, bags, [nb], tree, nb)
end

function _tree_bags(order::Vector{Int}, g::SimpleGraph{TG}) where{TG}

    G = deepcopy(g)
    B = Vector{Vector{Int}}() # bags
    T = SimpleGraph() # tree
    orphan_bags = Int[] # Array to hold parentless vertices of T

    for u in reverse(order)
        # Eliminate u from G: form a clique and remove u,
        # Take the clique formed by eliminating u as the next possible bag
        Nᵤ = neighbors(G, u)
        b = [u]
        ib = length(B) + 1
        if !isempty(Nᵤ) b = [Nᵤ; u] end
        G = eliminate!(G, u)

        drop_bag = false
        # keep only maximal cliques
        for i in orphan_bags
            l = B[i]
            if Set(b) == Set(intersect(b, l))
                b = l
                ib = i
                drop_bag = true
                break
            end
        end

        # add a new vetex to the tree for the next bag
        # and append it to the parentless vertices.
        if !drop_bag
            push!(B, b)
            add_vertex!(T)
            push!(orphan_bags, ib)
        end

        # Check if the new bag is a parent of any of the
        # orphan vertices and update the list of orphans.
        for i in orphan_bags
            l = B[i]
            b∩l = intersect(b, l)
            if u in b∩l && !issubset(b, b∩l)
                orphan_bags = setdiff(orphan_bags, [i])
                add_edge!(T, i, ib)
            end
        end
    end
    
    return B, T
end

function construct_tree!(d_tree::DecompositionTreeNode{TE}, bags::Vector{Vector{TE}}, used_bags::Vector{Int}, tree::SimpleGraph{TE}, u::Int) where{TE}
    neibs = neighbors(tree, u)
    childs = setdiff(neibs, used_bags)
    used_bags = neibs ∪ used_bags

    for i in childs
        add_child!(d_tree, Set(bags[i]))
        construct_tree!(d_tree.children[end], bags, used_bags, tree, i)
    end

    return d_tree
end

using TreeWidthSolver: bit_neighbors, open_neighbors, closed_neighbors, is_clique, bit_induced_subgraph, bit_connected_components

@testset "MaskedBitGraphs" begin
    g = random_regular_graph(10, 3)
    bg = MaskedBitGraph(g)
    @test nv(bg) == 10

    g = random_regular_graph(120, 3)
    bg = MaskedBitGraph(g)
    @test nv(bg) == 120

    sg = bit_induced_subgraph(bg, bmask(LongLongUInt{2}, 1:10))
    @test nv(sg) == 10
end

@testset "neighbors" begin
    g = smallgraph(:petersen)
    bg = MaskedBitGraph(g)
    for i in 1:10
        @test bit_neighbors(bg, i) == bmask(LongLongUInt{1}, g.fadjlist[i])
    end
    sub_bg = bit_induced_subgraph(bg, bmask(LongLongUInt{1}, 1:5))
    sub_g = induced_subgraph(g, 1:5)[1]

    for i in 1:5
        @test bit_neighbors(sub_bg, i) == bmask(LongLongUInt{1}, sub_g.fadjlist[i])
    end

    @test closed_neighbors(bg, bmask(LongLongUInt{1}, 1:2)) == bmask(LongLongUInt{1}, [1, 2, 3, 5, 6, 7])
    @test open_neighbors(bg, bmask(LongLongUInt{1}, 1:2)) == bmask(LongLongUInt{1}, [3, 5, 6, 7])
    @test closed_neighbors(sub_bg, bmask(LongLongUInt{1}, 1:2)) == bmask(LongLongUInt{1}, [1, 2, 3, 5])
    @test open_neighbors(sub_bg, bmask(LongLongUInt{1}, 1:2)) == bmask(LongLongUInt{1}, [3, 5])
end

@testset "connected component" begin
    g = graph_from_tuples(6, [(1, 2), (2, 3), (1, 3), (4, 5), (5, 6), (4, 6)])
    bg = MaskedBitGraph(g)
    
    @test has_edge(bg, 1, 2)
    @test !has_edge(bg, 1, 4)

    @test bit_connected_components(bg) == [bmask(LongLongUInt{1}, 1:3), bmask(LongLongUInt{1}, 4:6)]

    add_edge!(bg, 3, 4)
    @test bit_connected_components(bg) == [bmask(LongLongUInt{1}, 1:6)]

    @test bit_connected_components(bg, mask = bmask(LongLongUInt{1}, [1, 2, 4, 5, 6])) == [bmask(LongLongUInt{1}, 1:2), bmask(LongLongUInt{1}, 4:6)]
end

@testset "clique" begin
    g = graph_from_tuples(4, [(1, 2), (2, 3), (1, 3), (1, 4), (2, 4)])
    bg = MaskedBitGraph(g)
    @test is_clique(bg, bmask(LongLongUInt{1}, 1:3))
    @test !is_clique(bg, bmask(LongLongUInt{1}, 1:4))
    add_edge!(bg, 3, 4)
    @test is_clique(bg, bmask(LongLongUInt{1}, 1:4))
end

using TreeWidthSolver: bit2id

@testset "LongLongUInt bit2id" begin
    b = bmask(LongLongUInt{1}, 1:10)
    @test bit2id(b, 64) == collect(1:10)

    b = bmask(LongLongUInt{2}, 1:65)
    @test bit2id(b, 128) == collect(1:65)
end

@testset "BT-DP algorithm" begin

    g = graph_from_tuples(5, [(1, 2), (2, 3), (3, 4), (1, 4), (4, 5)])
    @test exact_treewidth(g) ≈ 2

    # 1d line
    g = graph_from_tuples(6, [(1, 2), (2, 3), (3, 4), (4, 5), (5, 6)])
    @test exact_treewidth(g) ≈ 1

    # square
    g = graph_from_tuples(4, [(1, 2), (2, 3), (3, 4), (4, 1)])
    @test exact_treewidth(g) ≈ 2

    # small graphs

    graph_names = [:bull, :chvatal, :cubical, :desargues, :diamond, :dodecahedral, :frucht, :heawood, :house, :housex, :icosahedral, :karate, :krackhardtkite, :moebiuskantor, :octahedral, :pappus, :petersen, :sedgewickmaze, :tetrahedral, :truncatedtetrahedron]
    # these results are calculated by C++ package triangulator for tree width
    # see https://github.com/Laakeri/triangulator-msc
    tws = [2, 6, 3, 6, 2, 6, 3, 5, 2, 3, 6, 5, 3, 5, 4, 6, 4, 2, 3, 4]
    for (i, graph_name) in enumerate(graph_names)
        g = smallgraph(graph_name)
        tw = exact_treewidth(g)
        @test tw ≈ tws[i]

        Π = all_pmc_enmu(MaskedBitGraph(g), false)
        td = bt_algorithm(MaskedBitGraph(g), Π, ones(ne(g)), false, true)

        @test td.tw == tw
        @test width(td.tree) == tw

        order = elimination_order(g)
        @test Set(unique!(vcat(order...))) == Set(1:nv(g))

        labeled_order = elimination_order(g, labels = ["v$i" for i in 1:nv(g)])
        @test Set(unique!(vcat(labeled_order...))) == Set(["v$i" for i in 1:nv(g)])
    end
end

# generating all minimum separators of a given simple graph
# following the method provided in Berry, Anne, Jean-Paul Bordat, and Olivier Cogis. “Generating All the Minimal Separators of a Graph.” In Graph-Theoretic Concepts in Computer Science, edited by Peter Widmayer, Gabriele Neyer, and Stephan Eidenbenz, 1665:167–72. Lecture Notes in Computer Science. Berlin, Heidelberg: Springer Berlin Heidelberg, 1999. https://doi.org/10.1007/3-540-46784-X_17.

function is_min_sep(bg::MaskedBitGraph{INT}, S::INT; mask::INT = bg.mask) where{INT}
    flag = 0
    comps = bit_connected_components(bg, mask = (mask & ~S))
    for comp in comps
        if is_full_component(bg, S, comp, mask = mask)
            flag += 1
        end
    end
    return flag ≥ 2
end

function all_min_sep_naive(bg::MaskedBitGraph{INT}) where{INT}
    Δ = Vector{INT}()
    for sets in combinations(1:N(bg))
        S = bmask(INT, sets)
        is_min_sep(bg, S) && push!(Δ, S)
    end
    return Δ
end

function all_min_sep(bg::MaskedBitGraph{INT}, verbose::Bool) where{INT}
    verbose && @info "computing all minimal separators"

    # initialization
    ΔT = Vector{INT}()

    for v in 1:N(bg)
        (readbit(bg.mask, v) == 0) && continue
        close_neibs = bit_neighbors(bg, v) | bmask(INT, v)
        for comp in bit_connected_components(bg, mask = ~close_neibs)
            ons = open_neighbors(bg, comp)
            if (ons != 0) && (ons ∉ ΔT)
                push!(ΔT, ons)
            end
        end
    end

    # it seems that SortedSet is not as good as Set
    # ΔS = SortedSet(ΔT)
    ΔS = Set(ΔT)

    i = 1
    while i ≤ length(ΔT)

        (verbose && (i%10000 == 0 || (i < 10000 && i%1000 ==0) || (i < 1000 && i%100==0) || (i<100 && i%10==0))) && @info "allminseps: $i, $(length(ΔT))"

        S = ΔT[i]
        RS = Vector{INT}()
        for x in 1:N(bg)
            iszero(readbit(S, x)) && continue
            for comp in bit_connected_components(bg, mask = ~(S | bit_neighbors(bg, x)))
                push!(RS, open_neighbors(bg, comp))
            end
        end

        for rs in RS
            if rs ∉ ΔS
                push!(ΔS, rs)
                push!(ΔT, rs)
            end
        end
        i += 1
    end

    verbose && @info "all minimal separators computed, total: $(length(ΔT))"

    return ΔT
end

Base.show(io::IO, val::LongLongUInt{C}) where{C} = print(io, BitStr{64 * C}(val))

function bit2id(bit::INT, N::Int) where{INT}
    id = Vector{Int}()
    for i in 1:N
        if readbit(bit, i) == 1
            push!(id, i)
        end
    end
    return id
end

function Base.hash(bits_tuple::Tuple{LongLongUInt{C}, Vararg{LongLongUInt{C}, M}}) where{M, C}
    N = M + 1
    hash0 = Base.hash(bits_tuple[1].content)
    for i in 2:N
        hash0 = Base.hash(bits_tuple[i].content, hash0)
    end
    return hash0
end

"""
    mutable struct MaskedBitGraph{INT}

A mutable struct representing a masked bit graph.

# Fields
- `MaskedBitGraph::Vector{INT}`: Stores the adjacency matrix as a vector of BitStr.
- `fadjlist::Vector{Vector{Int}}`: Stores the adjacency list, providing information about the sparse graph.
- `mask::INT`: The mask for the graph.

"""
mutable struct MaskedBitGraph{INT}
    bitgraph::Vector{INT} # store the adjacency matrix as vector of BitStr
    fadjlist::Vector{Vector{Int}} # store the adjacency list, informate of sparse graph
    mask::INT # mask for the graph
end

function MaskedBitGraph(g::SimpleGraph)
    N = nv(g)
    INT = LongLongUInt{N ÷ 64 + 1}
    bitgraph = INT[bmask(INT, g.fadjlist[i]) for i in 1:N]
    mask = bmask(INT, 1:N)
    return MaskedBitGraph(bitgraph, deepcopy(g.fadjlist), mask)
end

function Graphs.nv(bg::MaskedBitGraph{INT}) where{INT}
    return count_ones(bg.mask)
end

N(bg::MaskedBitGraph{INT}) where{INT} = length(bg.bitgraph)

Base.show(io::IO, bg::MaskedBitGraph{INT}) where {INT} = print(io, "MaskedBitGraph{$INT}, N: $(N(bg)), nv: $(nv(bg)), mask: $(BitStr{N(bg)}(bg.mask))")
Base.copy(bg::MaskedBitGraph{INT}) where{INT} = MaskedBitGraph(copy(bg.bitgraph), deepcopy(bg.fadjlist), bg.mask)

function Graphs.neighbors(bg::MaskedBitGraph{INT}, v::Int) where{INT}
    bit_nebi = bit_neighbors(bg, v)
    return bit2id(bit_nebi, N(bg))
end

function bit_neighbors(bg::MaskedBitGraph{INT}, v::Int) where{INT}
    return bg.bitgraph[v] & bg.mask
end

function closed_neighbors(bg::MaskedBitGraph{INT}, vs::INT) where{INT}
    nebis = zero(INT)
    for i in 1:N(bg)
        iszero(readbit(vs, i)) && continue
        nebis |= bg.bitgraph[i]
    end
    return (nebis & bg.mask) | vs
end

function open_neighbors(bg::MaskedBitGraph{INT}, vs::INT) where{INT}
    nebis = zero(INT)
    for i in 1:N(bg)
        iszero(readbit(vs, i)) && continue
        nebis |= bg.bitgraph[i]
    end
    return (nebis & bg.mask) & ~vs
end

function Graphs.has_edge(bg::MaskedBitGraph{INT}, v::Int, u::Int) where{INT}
    @assert (readbit(bg.mask, v) == 1) && (readbit(bg.mask, u) == 1)
    return isone(readbit(bg.bitgraph[v], u))
end

function Graphs.add_edge!(bg::MaskedBitGraph{INT}, src::Int, dst::Int) where{INT}
    bg.bitgraph[src] = bg.bitgraph[src] | bmask(INT, dst)
    bg.bitgraph[dst] = bg.bitgraph[dst] | bmask(INT, src)
    push!(bg.fadjlist[src], dst)
    push!(bg.fadjlist[dst], src)
    nothing
end

# consider induced subgraph with mask
function bit_induced_subgraph(bg::MaskedBitGraph{INT}, vertices::INT) where{INT}
    sub_bg = copy(bg)
    sub_bg.mask = sub_bg.mask & vertices
    return sub_bg
end

# we actually need neighobors of connected components of the induced subgraph

# mask is a parameter, to aviod creating new MaskedBitGraph when considering induced subgraph
function bit_connected_components(bg::MaskedBitGraph{INT}; mask::INT = bg.mask) where{INT}
    comps = Vector{INT}()
    labels = ~mask

    for i in 1:N(bg)
        readbit(bg.mask, i) == 0 && continue
        readbit(labels, i) != 0 && continue
        comp = bmask(INT, i)
        labels = labels | comp
        comp, labels = _bit_connected_components(bg, comp, labels, i)
        push!(comps, comp & bg.mask)
    end
    return comps
end

function _bit_connected_components(bg::MaskedBitGraph{INT}, comp::INT, labels::INT, i::Int) where{INT}
    active_nebis = (bit_neighbors(bg, i) & ~labels)
    (active_nebis == 0) && return comp, labels
    comp = comp | active_nebis
    labels = labels | active_nebis
    for j in bg.fadjlist[i]
        (iszero(readbit(active_nebis, j))) &&  continue
        comp, labels = _bit_connected_components(bg, comp, labels, j)
    end
    return comp, labels
end

function is_full_component(bg::MaskedBitGraph{INT}, S::INT, comp::INT; mask::INT = bg.mask) where{INT}
    return (open_neighbors(bg, comp) & mask) == S
end

function is_clique(bg::MaskedBitGraph{INT}, S::INT) where{INT}
    flag = S
    for i in 1:N(bg)
        iszero(readbit(S, i)) && continue
        flag &= (bg.bitgraph[i] | bmask(INT, i))
    end
    return (flag & S) == S
end

function full_components(bg::MaskedBitGraph{INT}, S::INT) where{INT}
    comps = bit_connected_components(bg, mask = ~S & bg.mask)
    return [comp for comp in comps if is_full_component(bg, S, comp)]
end

function res_components(bg::MaskedBitGraph{INT}, C::INT, Ω::INT) where{INT}
    mask = C & ~Ω
    ccs = bit_connected_components(bg, mask = mask)
    return ccs
end

module TreeWidthSolver

using SparseArrays, AbstractTrees, Combinatorics, Graphs, BitBasis

export MaskedBitGraph

# interface for graphs
export line_graph, simple_graph, adjacency_mat
export graph_from_gr, graph_from_tuples, save_graph

# interface about the bt algorithm
export is_min_sep, all_min_sep, all_min_sep_naive
export is_pmc, all_pmc_naive, all_pmc_enmu, all_pmc_bt
export bt_algorithm

# highest level interface
export exact_treewidth, decomposition_tree, elimination_order
export is_treedecomposition

export DecompositionTreeNode, TreeDecomposition, EliminationOrder, width

# the data structure
include("bitbasis.jl")
include("bitgraphs.jl")

# the graph operations
include("graphs.jl")
include("tree_decomposition.jl")

# the BT algorithm
include("min_separator.jl")
include("max_clique.jl")
include("bt_algorithm.jl")

include("treewidth.jl")

end

using TreeWidthSolver: all_pmc_bt

@testset "maximum cliques" begin
    for n in 6:2:14
        g = random_regular_graph(n, 3)
        bg = MaskedBitGraph(g)
        Π_enmu = all_pmc_enmu(bg, false)
        Π_bt = all_pmc_bt(bg)
        Π_naive = all_pmc_naive(bg)
        for Ω in Π_enmu
            @test is_pmc(bg, Ω)
        end
        @test length(Π_enmu) == length(Π_naive)
        @test Set(Π_enmu) == Set(Π_naive) == Set(Π_bt)
    end
end

using TreeWidthSolver
using Graphs, BitBasis
using Test
using Random

Random.seed!(1234)

@testset "TreeWidthSolver.jl" begin
    include("bitbasis.jl")
    include("graphs.jl")
    include("bitgraphs.jl")
    include("tree_decomposition.jl")
    include("min_separator.jl")
    include("max_clique.jl")
    include("treewidth.jl")
end

# listing all potential maximal cliques in a graph
# following the method provided in BouchitteÃ, Vincent, and Ioan Todinca. “Listing All Potential Maximal Cliques of a Graph.” Theoretical Computer Science, 2002.
# Tuukka Korhonen, "Finding Optimal Tree Decompositions", 2020. https://tuukkakorhonen.com/papers/msc-thesis.pdf

function has_full_component(bg::MaskedBitGraph{INT}, S::INT, comps::Vector{INT}) where{INT}
    for comp in comps
        if is_full_component(bg, S, comp)
            return true
        end
    end
    return false
end

function is_cliquish(bg::MaskedBitGraph{INT}, S::INT, comps::Vector{INT}) where{INT}
    new_MaskedBitGraph = copy(bg.bitgraph)
    for i in 1:N(bg)
        iszero(readbit(S, i)) && continue
        new_MaskedBitGraph[i] |= bmask(INT, i)
    end

    for comp in comps
        ons = open_neighbors(bg, comp)
        for i in 1:N(bg)
            iszero(readbit(ons, i)) && continue
            new_MaskedBitGraph[i] |= ons
        end
    end
    new_S = S
    for i in 1:N(bg)
        iszero(readbit(S, i)) && continue
        new_S &= new_MaskedBitGraph[i]
    end
    return (new_S == S)
end

function is_pmc(bg::MaskedBitGraph{INT}, S::INT) where{INT}
    comps = bit_connected_components(bg, mask = (~S & bg.mask))
    if has_full_component(bg, S, comps)
        return false
    else
        return is_cliquish(bg, S, comps)
    end
end

function all_pmc_naive(bg::MaskedBitGraph{INT}) where{INT}
    Π = Vector{INT}()
    for sets in combinations(1:N(bg))
        S = bmask(INT, sets)
        is_pmc(bg, S) && push!(Π, S)
    end
    return Π
end

function vertex_order!(bg::MaskedBitGraph{INT}, vo::Vector{Int}) where{INT}
    nebis = open_neighbors(bg, bmask(INT, vo))
    for nebi in 1:N(bg)
        iszero(readbit(nebis, nebi)) && continue
        if nebi ∉ vo
            push!(vo, nebi)
            return vertex_order!(bg, vo)
        end
    end
    return vo
end


# the extend_Π! and all_pmc_enmu are the method from the paper: Tuukka Korhonen, "Finding Optimal Tree Decompositions", 2020. https://tuukkakorhonen.com/papers/msc-thesis.pdf
function extend_Π!(Π::Vector{INT}, Πi::Vector{INT}, vo::Vector{Int}, bg::MaskedBitGraph{INT}) where{INT}
    cbg = copy(bg)
    for Ω in Πi
        for i in 1:length(vo)
            removed_vertex = length(vo) == i ? zero(INT) : bmask(INT, vo[i + 1:end])
            cbg.mask = ~removed_vertex & bg.mask
            comps = bit_connected_components(cbg, mask = cbg.mask & ~Ω)
            has_full_component(cbg, Ω, comps) && (Ω |= bmask(INT, vo[i]))
        end
        push!(Π, Ω)
    end
    return Π
end

function all_pmc_enmu(bg::MaskedBitGraph{INT}, verbose::Bool) where{INT}
    Δ = all_min_sep(bg, verbose)
    Π = Vector{INT}()

    vo = vertex_order!(bg, Int[1])

    verbose && @info "computing all potential maximal cliques"
    bg0 = copy(bg)
    for i in 1:N(bg) - 1

        verbose && @info "vertices: $(N(bg) - i), Δ: $(length(Δ)), Π: $(length(Π))"

        Πi = Vector{INT}()
        a = vo[i]
        bmask_a = bmask(INT, a)
        ΔT = Vector{INT}()
        ΔN = Vector{INT}()
        ΔS = Vector{INT}()
        for S in Δ
            if readbit(S, a) == 1
                push!(ΔT, S & ~bmask_a)
            elseif is_min_sep(bg0, S, mask = bg.mask & ~bmask(INT, vo[1:i]))
                push!(ΔN, S)
            else
                push!(ΔS, S)
            end
        end

        for S in ΔN ∪ ΔS
            is_pmc(bg0, S | bmask_a) && push!(Πi, S | bmask_a)
        end

        for S in ΔS, T in ΔT
            Sn = S | T
            is_pmc(bg0, Sn) && push!(Πi, Sn)
        end

        extend_Π!(Π, Πi, vo[i - 1:-1:1], bg)

        Δ = ΔT ∪ ΔN
        bg0.mask = bg.mask & ~bmask(INT, vo[1:i])
    end
    extend_Π!(Π, [bmask(INT, vo[end])], vo[end-1:-1:1], bg)
    unique!(Π)

    verbose && @info "computing all potential maximal cliques done, total: $(length(Π))"

    return Π
end

# one_more_vertex and all_pmc_bt are from the original version: BouchitteÃ, Vincent, and Ioan Todinca. “Listing All Potential Maximal Cliques of a Graph.” Theoretical Computer Science, 2002.
function one_more_vertex(G_1::MaskedBitGraph{INT}, G_0::MaskedBitGraph{INT}, Π_0::Vector{INT}, Δ_1::Vector{INT}, Δ_0::Vector{INT}) where{INT}
    bmask_a = G_1.mask & ~G_0.mask
    a = bit2id(bmask_a, N(G_1))[1]

    Π_1 = Vector{INT}()
    SΔ_0 = Set(Δ_0)

    for Ω_0 in Π_0
        cs_Ω = bit_connected_components(G_1, mask = ~Ω_0 & G_1.mask)
        if has_full_component(G_1, Ω_0, cs_Ω)
            push!(Π_1, Ω_0 | bmask_a)
        else
            push!(Π_1, Ω_0)
        end
    end

    for S in Δ_1
        if is_pmc(G_1, S | bmask_a)
            push!(Π_1, S | bmask_a)
        end
        if (readbit(S, a) == 0) && (S ∉ SΔ_0)
            fcs = bit_connected_components(G_1, mask = ~S & G_1.mask)
            for T in Δ_1
                for C in fcs
                    t = S | (T & C)
                    if is_pmc(G_1, t)
                        push!(Π_1, t)
                    end
                end
            end
        end
    end

    return Π_1
end

function all_pmc_bt(bg::MaskedBitGraph{INT}) where{INT}
    vo = vertex_order!(bg, Int[1]) # order to remove vertices from the graph, starting from 1, keep the graph connected
    G0 = bit_induced_subgraph(bg, bmask(INT, vo[1:1]))

    Π_G1 = [bmask(INT, vo[1])]
    Δ_G0 = Vector{INT}()

    for i in 2:N(bg)
        G1 = bit_induced_subgraph(bg, bmask(INT, vo[1:i]))
        Δ_G1 = all_min_sep(G1, false)
        Π_G1 = one_more_vertex(G1, G0, Π_G1, Δ_G1, Δ_G0)
        Δ_G0 = Δ_G1
        G0 = G1
    end

    return unique!(Π_G1)
end

@testset "minimum separators" begin
    for n in 6:2:14
        g = random_regular_graph(n, 3)
        bg = MaskedBitGraph(g)
        @test Set(all_min_sep(bg, false)) == Set(all_min_sep_naive(bg))
    end
end

"""
    graph_from_tuples(n::Int, edgs)

Constructs a graph from a list of tuples representing edges.

# Arguments
- `n::Int`: The number of vertices in the graph.
- `edgs`: A list of tuples representing the edges of the graph.

# Returns
A graph object.

"""
function graph_from_tuples(n::Int, edgs)
    g = SimpleGraph(n)
    for (i, j) in edgs
        add_edge!(g, i, j)
    end
    g
end

"""
    graph_from_gr(filename)

Reads a graph from a file in the .gr format (PACE format) and returns a `SimpleGraph` object.

# Arguments
- `filename`: The path to the input file.

# Returns
- `graph`: A `SimpleGraph` object representing the graph.

"""
function graph_from_gr(filename)
    open(filename, "r") do file
        line = readline(file)
        first_str, second_str, first_num, second_num = split(line)
        n = parse(Int64, first_num)
        graph = SimpleGraph(n)

        for line in eachline(file)
            v1, v2 = split(line)
            add_edge!(graph, parse(Int64, v1), parse(Int64, v2))
        end
        return graph
    end
end

"""
    function save_graph(g::SimpleGraph, filename)

The graph will be saved as .gr format, in PACE format, where the first line is `p tw nv ne`, and the following lines are the edges `src dst`
"""
function save_graph(g::SimpleGraph, filename)
    open(filename, "w") do file
        println(file, "p tw $(nv(g)) $(ne(g))")
        for e in edges(g)
            println(file, "$(src(e)) $(dst(e))")
        end
    end
    nothing
end

"""
    adjacency_mat(graph::SimpleGraph)

Constructs the adjacency matrix of a given `SimpleGraph`.

# Arguments
- `graph::SimpleGraph`: The input graph.

# Returns
- `SparseMatrixCSC{Int}`: The adjacency matrix of the graph.
"""
function adjacency_mat(graph::SimpleGraph)
    rows = Int[]
    cols = Int[]
    for (i,edge) in enumerate(edges(graph))
        push!(rows, edge.src, edge.dst)
        push!(cols, i, i)
    end
    return sparse(rows, cols, ones(Int, length(rows)))
end

"""
    line_graph(adjacency_mat::SparseMatrixCSC)

Constructs the line graph of a given graph represented by its adjacency matrix.

# Arguments
- `adjacency_mat::SparseMatrixCSC`: The adjacency matrix of the input graph, where the columns represent the vertices and the rows represent the edges. The value is `true` if the edge is connected to the vertex.

# Returns
- `g::SimpleGraph`: The line graph of the input graph.

"""
function line_graph(adjacency_mat::SparseMatrixCSC)
    nv = size(adjacency_mat, 1)
    ne = size(adjacency_mat, 2)

    g = SimpleGraph(ne)
    for v in 1:nv
        ecv = adjacency_mat[v, :].nzind # edges connected to v
        for i in 1:length(ecv)
            for j in i+1:length(ecv)
                add_edge!(g, ecv[i], ecv[j])
            end
        end
    end

    return g
end
function line_graph(g::SimpleGraph)
    return line_graph(adjacency_mat(g))
end


"""
    simple_graph(adjacency_mat::SparseMatrixCSC)

Constructs a simple undirected graph from a sparse adjacency matrix.

# Arguments
- `adjacency_mat::SparseMatrixCSC`: The sparse adjacency matrix representing the graph.

# Returns
- `g::SimpleGraph`: The constructed simple undirected graph.

"""
function simple_graph(adjacency_mat::SparseMatrixCSC)
    ne = size(adjacency_mat, 2)
    nv = size(adjacency_mat, 1)
    g = SimpleGraph(nv)

    for e in 1:ne
        vce = adjacency_mat[:, e].nzind # vertices connected to e
        for i in 1:length(vce)
            for j in i+1:length(vce)
                add_edge!(g, vce[i], vce[j])
            end
        end
    end

    return g
end

function eliminate!(g::SimpleGraph{TG}, v::TG) where{TG}
    neibs = copy(neighbors(g, v))

    for i in 1:length(neibs)
        rem_edge!(g, neibs[i], v)
    end

    for i in 1:length(neibs) - 1
        for j in i + 1:length(neibs)
            add_edge!(g, neibs[i], neibs[j])
        end
    end

    return g
end

using TreeWidthSolver
using Documenter

DocMeta.setdocmeta!(TreeWidthSolver, :DocTestSetup, :(using TreeWidthSolver); recursive=true)

makedocs(;
    modules=[TreeWidthSolver],
    authors="Xuanzhao Gao <gaoxuanzhao@gmail.com> and contributors",
    sitename="TreeWidthSolver.jl",
    format=Documenter.HTML(;
        canonical="https://ArrogantGao.github.io/TreeWidthSolver.jl",
        edit_link="main",
        assets=String[],
    ),
    pages=["Home" => "index.md", "Manual" => "manual.md", "Contraction Order" => "contractionorder.md", "Performance" => "performance.md"],
)

deploydocs(;
    repo="github.com/ArrogantGao/TreeWidthSolver.jl",
    devbranch="main",
)

# The Bouchitte-Todinca algorithm for computing the exact tree width of a given graph.
# References:
# Bouchitté, Vincent, and Ioan Todinca. “Treewidth and Minimum Fill-in: Grouping the Minimal Separators.” SIAM Journal on Computing 31, no. 1 (January 2001): 212–32. https://doi.org/10.1137/S0097539799359683
# Korhonen, Tuukka, Jeremias Berg, and Matti Järvisalo. “Solving Graph Problems via Potential Maximal Cliques: An Experimental Evaluation of the Bouchitté--Todinca Algorithm.” ACM Journal of Experimental Algorithmics 24 (December 17, 2019): 1–19. https://doi.org/10.1145/3301297.

# total weights of a tree bag
function clique_width(S::INT, weights::Vector{TW}) where {INT, TW}
    fw = zero(TW)
    for i in 1:length(weights)
        readbit(S, i) == 1 && (fw += weights[i])
    end
    return fw - one(TW)
end

# weights are the log2 dims of the indices
function bt_algorithm(bg::MaskedBitGraph{INT}, Π::Vector{INT}, weights::Vector{TW}, verbose::Bool, construct::Bool) where{INT, TW}

    verbose && @info "computing the exact treewidth using the Bouchitté-Todinca algorithm"
    verbose && @info "precomputation phase"
    # precomputation phase
    T = Vector{Tuple{INT, INT, INT}}()
    for Ω in Π
        push!(T, (Ω, zero(INT), bg.mask))
        for D in bit_connected_components(bg, mask = ~Ω & bg.mask)
            S = open_neighbors(bg, D)
            for C in full_components(bg, S)
                if ((Ω | (S | C)) == (S | C)) && ((S | Ω) == Ω) && (S ≠ Ω)
                    push!(T, (Ω, S, C))
                end
            end
        end
    end

    unique!(T)
    sort!(T, by = x -> count_ones(x[2]) + count_ones(x[3]))

    verbose && @info "precomputation phase completed, total: $(length(T))"

    # dynamic programing phase
    dp = Dict{Tuple{INT, INT}, TW}()
    optChoice = Dict{Tuple{INT, INT}, INT}()
    for t in T
        Ω, S, C = t
        dp[(S, C)] = typemax(TW)
    end

    lengthT = length(T)
    for (i, t) in enumerate(T)
        Ω, S, C = t
        cost = clique_width(Ω, weights)

        CS2 = res_components(bg, C, Ω)
        for C2 in CS2
            S2 = open_neighbors(bg, C2)
            cost = max(cost, dp[(S2, C2)])
        end
        if cost < dp[(S, C)]
            dp[(S, C)] = cost
            optChoice[(S, C)] = Ω
        end
    end

    tw = dp[(bmask(INT, 0), bg.mask)]

    verbose && @info "computing the exact treewidth done, treewidth: $tw"
    !construct && return TreeDecomposition(tw, DecompositionTreeNode(Set{Int}()))

    verbose && @info "reconstruction phase"
    # reconstrcution step
    tree = construct_tree(bg, optChoice)
    verbose && @info "reconstruction phase done"

    return TreeDecomposition(tw, tree)
end

function construct_tree(bg::MaskedBitGraph{INT}, optChoice::Dict{Tuple{INT, INT}, INT}) where{INT}
    Ω0 = optChoice[(bmask(INT, 0), bg.mask)]
    root_node = DecompositionTreeNode(bit2id(Ω0, N(bg)))
    _construct_tree!(root_node, Ω0, optChoice, bg, bg.mask)
    return root_node
end

function _construct_tree!(node::DecompositionTreeNode{Int}, bag::INT, optChoice::Dict{Tuple{INT, INT}, INT}, bg::MaskedBitGraph{INT}, C::INT) where{INT}
    Ω = bag
    CS2 = res_components(bg, C, Ω)
    for C2 in CS2
        S2 = open_neighbors(bg, C2)
        Ω2 = optChoice[(S2, C2)]
        add_child!(node, bit2id(Ω2, N(bg)))
        _construct_tree!(node.children[end], Ω2, optChoice, bg, C2)
    end
    return nothing
end

"""
	exact_treewidth(g::SimpleGraph{TG}; weights::Vector{TW} = ones(nv(g)), verbose::Bool = false) where {TG, TW}

Compute the exact treewidth of a given graph `g` using the BT algorithm.

# Arguments
- `g::SimpleGraph{TG}`: The input graph.
- `weights::Vector{TW} = ones(nv(g))`: The weights of the vertices in the graph. Default is equal weights for all vertices.
- `verbose::Bool = false`: Whether to print verbose output. Default is `false`.

# Returns
- `tw`: The treewidth of the graph.

"""
function exact_treewidth(g::SimpleGraph{TG}; weights::Vector{TW} = ones(nv(g)), verbose::Bool = false) where {TG, TW}
	bg = MaskedBitGraph(g)
	Π = all_pmc_enmu(bg, verbose)
	td = bt_algorithm(bg, Π, weights, verbose, false)
	return td.tw
end

"""
	decomposition_tree(g::SimpleGraph{TG}; labels::Vector{TL} = collect(1:nv(g)), weights::Vector{TW} = ones(nv(g)), verbose::Bool = false) where {TG, TW, TL}

Constructs a decomposition tree for a given simple graph `g`.

# Arguments
- `g::SimpleGraph{TG}`: The input graph.
- `labels::Vector{TL}`: (optional) The labels for the vertices of the graph. Default is `collect(1:nv(g))`.
- `weights::Vector{TW}`: (optional) The weights for the vertices of the graph. Default is `ones(nv(g))`.
- `verbose::Bool`: (optional) Whether to print verbose output. Default is `false`.

# Returns
- `TreeDecomposition`: The resulting decomposition tree, where treewidht is stored in `td.tw` and the tree is stored in `td.tree`.

"""
function decomposition_tree(g::SimpleGraph{TG}; labels::Vector{TL} = collect(1:nv(g)), weights::Vector{TW} = ones(nv(g)), verbose::Bool = false) where {TG, TW, TL}
	bg = MaskedBitGraph(g)
	Π = all_pmc_enmu(bg, verbose)
	td = bt_algorithm(bg, Π, weights, verbose, true)
	labeled_tree = tree_labeling(td.tree, labels)
	return TreeDecomposition(td.tw, labeled_tree)
end

"""
    decomposition_tree(g::SimpleGraph{TG}, orders::Union{Vector{Vector{TE}}, Vector{TE}}; labels::Vector{TL} = [1:length(vertices(g))...]) where {TG, TE, TL}

Constructs a decomposition tree for a given simple graph `g` based on the provided orders.

# Arguments
- `g::SimpleGraph{TG}`: The input graph.
- `orders::Union{Vector{Vector{TE}}, Vector{TE}}`: The orders for constructing the decomposition tree. Can be a vector of vectors or a single vector.
- `labels::Vector{TL}`: (optional) The labels for the vertices of the graph. Default is `collect(1:nv(g))`.

# Returns
- `TreeDecomposition`: The resulting decomposition tree, where the tree is labeled according to the provided labels.

# Raises
- `AssertionError`: If the length of `new_orders` does not match the number of vertices in `g`, if `new_orders` contains duplicates, or if the length of `labels` does not match the length of `new_orders`.

"""
function decomposition_tree(g::SimpleGraph{TG}, orders::Union{Vector{Vector{TE}}, Vector{TE}}; labels::Vector{TL} = [1:length(vertices(g))...]) where {TG, TE, TL}

	new_orders = (orders isa Vector{Vector{TE}}) ? vcat(orders...) : orders
	@assert length(new_orders) == nv(g)
	@assert unique(new_orders) == new_orders
	@assert length(labels) == length(new_orders)

	labels_dict = Dict(labels[i] => i for i in 1:length(labels))
	int_orders = [labels_dict[i] for i in new_orders]

	tree = order2tree(int_orders, g)

	return tree_labeling(tree, labels)
end

"""
	elimination_order(g::SimpleGraph{TG}; labels::Vector{TL} = collect(1:nv(g)), weights::Vector{TW} = ones(nv(g)), verbose::Bool = false) where {TG, TL, TW}

Compute the elimination order of a graph `g` using the BT algorithm.

# Arguments
- `g::SimpleGraph{TG}`: The input graph.
- `labels::Vector{TL}`: (optional) Labels for the vertices of `g`. Default is `collect(1:nv(g))`.
- `weights::Vector{TW}`: (optional) Weights for the vertices of `g`. Default is `ones(nv(g))`.
- `verbose::Bool`: (optional) Whether to print verbose output. Default is `false`.

# Returns
- `labeled_eo::Vector{Vector{TL}}`: The elimination order of the graph `g`, where each vertex is labeled according to `labels`.

"""
function elimination_order(g::SimpleGraph{TG}; labels::Vector{TL} = collect(1:nv(g)), weights::Vector{TW} = ones(nv(g)), verbose::Bool = false) where {TG, TL, TW}
	td = decomposition_tree(g, labels = labels, weights = weights, verbose = verbose)
	eo = EliminationOrder(td.tree)
	return eo.order
end

using TreeWidthSolver: isleaf, add_child!

@testset "tree decompositions" begin
    n1 = DecompositionTreeNode([1, 2, 3])
    n2 = DecompositionTreeNode(Set([1, 2, 3]))
    @test isleaf(n1)
    @test n1 == n2
    n3 = DecompositionTreeNode([1.0, 2.0, 3.0])
    @test n1 != n3

    add_child!(n1, [4, 5, 6])
    n1c = copy(n1)
    @test n1 == n1c

    tree = DecompositionTreeNode([1, 2, 3])
    add_child!(tree, [2, 3, 4])
    add_child!(tree, [1, 3, 5, 6])
    add_child!(tree.children[1], [4, 7])
    add_child!(tree.children[1], [4, 8, 9])

    @test width(tree) == 3
end

@testset "order2tree" begin
    g = smallgraph(:petersen)
    eo = elimination_order(g)
    td = decomposition_tree(g, eo)
    td_2 = decomposition_tree(g, vcat(eo...))
    tree = decomposition_tree(g).tree
    @test td == tree
    @test td == td_2

    @test is_treedecomposition(g, td)
    @test is_treedecomposition(g, td_2)
end

@testset "line graph" begin
    g = random_regular_graph(10, 3)
    adj_mat = adjacency_mat(g)
    g2 = simple_graph(adj_mat)
    @test g == g2

    lg1 = line_graph(g)
    lg2 = line_graph(adj_mat)
    @test lg1 == lg2
    @test nv(lg1) == ne(g)
end

# Manual for TreeWidthSolver.jl

## API

```@index
```

### Data Type

```@docs
MaskedBitGraph
```

```@docs
DecompositionTreeNode
```

```@docs
TreeDecomposition
```

### IO for Graphs

```@docs
graph_from_gr
```

```@docs
save_graph
```

```@docs
graph_from_tuples
```

### Hypergraph

```@docs
line_graph
```

```@docs
simple_graph
```

```@docs
adjacency_mat
```

### Treewidth

```@docs
exact_treewidth
```

```@docs
decomposition_tree
```

```@docs
elimination_order
```

# Performance

We benchmarked the performance of this package on different graphs. The results are shown below.

![](https://github.com/ArrogantGao/TreeWidthSolver_benchmark/blob/main/figs/time_cost.png?raw=true)

For more details, please refer to this repository: [https://github.com/ArrogantGao/TreeWidthSolver_benchmark](https://github.com/ArrogantGao/TreeWidthSolver_benchmark).

```@meta
CurrentModule = TreeWidthSolver
```

# TreeWidthSolver.jl

Documentation for [TreeWidthSolver](https://github.com/ArrogantGao/TreeWidthSolver.jl).

`TreeWidthSolver.jl` is a Julia package for solving the treewidth problem. It provides a simple interface for solving the treewidth problem and generating tree decompositions.
Currently we implemented the Bouchitté-Todinca algorithm for solving the treewidth problem, which is a exact algorithm for solving the treewidth problem.

For more details about the algorithms implemented in this package, please refer to the blog: [https://arrogantgao.github.io/blogs/treewidth/](https://arrogantgao.github.io/blogs/treewidth/).

This package is used as backend for finding the optimal tensor network contraction order in [OMEinsumContractionOrders.jl](https://github.com/TensorBFS/OMEinsumContractionOrders.jl), for more details please see the Contraction Order part.

## Installation

To install the package, enter the package manager by pressing `]` in the Julia REPL and run the following command:
```julia
pkg> add TreeWidthSolver
```
and everything should be set up.

## Usage

The user interface of this package is quite simple, three functions are provided:
* `exact_treewidth(g::SimpleGraph{TG}; weights::Vector{TW} = ones(nv(g)), verbose::Bool = false) where {TG, TW}`: Compute the exact treewidth of a given graph `g` using the BT algorithm.
* `decomposition_tree(g::SimpleGraph{TG}; labels::Vector{TL} = collect(1:nv(g)), weights::Vector{TW} = ones(nv(g)), verbose::Bool = false) where {TG, TW, TL}`: Compute the tree decomposition with minimal treewidth of a given graph `g` using the BT algorithm.
* `elimination_order(g::SimpleGraph{TG}; labels::Vector{TL} = collect(1:nv(g)), weights::Vector{TW} = ones(nv(g)), verbose::Bool = false) where {TG, TL, TW}`: Compute the elimination order of a given graph `g` using the BT algorithm.

Here are some examples:
```julia
julia> using TreeWidthSolver, Graphs

julia> g = smallgraph(:petersen)
{10, 15} undirected simple Int64 graph

# calculate the exact treewidth of the graph
julia> exact_treewidth(g)
4.0

# show more information
julia> exact_treewidth(g, verbose = true)
[ Info: computing all minimal separators
[ Info: allminseps: 10, 15
[ Info: all minimal separators computed, total: 15
[ Info: computing all potential maximal cliques
[ Info: vertices: 9, Δ: 15, Π: 0
[ Info: vertices: 8, Δ: 14, Π: 9
[ Info: vertices: 7, Δ: 13, Π: 16
[ Info: vertices: 6, Δ: 9, Π: 24
[ Info: vertices: 5, Δ: 6, Π: 35
[ Info: vertices: 4, Δ: 5, Π: 36
[ Info: vertices: 3, Δ: 2, Π: 43
[ Info: vertices: 2, Δ: 1, Π: 44
[ Info: vertices: 1, Δ: 1, Π: 44
[ Info: computing all potential maximal cliques done, total: 45
[ Info: computing the exact treewidth using the Bouchitté-Todinca algorithm
[ Info: precomputation phase
[ Info: precomputation phase completed, total: 135
[ Info: computing the exact treewidth done, treewidth: 4.0
4.0

# construct the tree decomposition
julia> decomposition_tree(g)
tree width: 4.0
tree decomposition:
Set([5, 6, 7, 3, 1])
├─ Set([7, 2, 3, 1])
├─ Set([5, 4, 6, 7, 3])
│  └─ Set([4, 6, 7, 9])
└─ Set([5, 6, 7, 10, 3])
   └─ Set([6, 10, 8, 3])

# similar for the elimination order
julia> elimination_order(g)
6-element Vector{Vector{Int64}}:
 [1, 3, 7, 6, 5]
 [10]
 [8]
 [4]
 [9]
 [2]

# one can also assign labels to the vertices
julia> elimination_order(g, labels = ['a':'j'...])
6-element Vector{Vector{Char}}:
 ['a', 'c', 'g', 'f', 'e']
 ['j']
 ['h']
 ['d']
 ['i']
 ['b']
```

## Questions and Contributions

If you have any questions or suggestions, please feel free to open an issue.
It is also welcomed for any suggestions about the issues marked as `enhancement`, please let us know if you have any idea about them.

# Contraction Order

This package can be used as backend for finding the optimal tensor network contraction order.

## OMEinsumContractionOrders.jl

A new optimizer has been added in [OMEinsumContractionOrders.jl](https://github.com/TensorBFS/OMEinsumContractionOrders.jl).

Here is an example of usage:
```julia
julia> using OMEinsum, OMEinsumContractionOrders

# define the contraction using Einstein summation
julia> code = ein"ijl, ikm, jkn, l, m, n -> "
ijl, ikm, jkn, l, m, n -> 

ulia> optimizer = ExactTreewidth()
ExactTreewidth{GreedyMethod{Float64, Float64}}(GreedyMethod{Float64, Float64}(0.0, 0.0, 1))

# set the size of the indices
julia> size_dict = uniformsize(code, 2)
Dict{Char, Int64} with 6 entries:
  'n' => 2
  'j' => 2
  'i' => 2
  'l' => 2
  'k' => 2
  'm' => 2

julia> optcode = optimize_code(code, size_dict, optimizer)
n, n -> 
├─ jk, jkn -> n
│  ├─ ij, ik -> jk
│  │  ├─ ijl, l -> ij
│  │  │  ├─ ijl
│  │  │  └─ l
│  │  └─ ikm, m -> ik
│  │     ├─ ikm
│  │     └─ m
│  └─ jkn
└─ n

# check the complexity
julia> contraction_complexity(optcode, size_dict)
Time complexity: 2^5.087462841250339
Space complexity: 2^2.0
Read-write complexity: 2^5.882643049361841

# check the results
julia> A = rand(2, 2, 2); B = rand(2, 2, 2); C = rand(2, 2, 2); D = rand(2); E = rand(2); F = rand(2);

julia> code(A, B, C, D, E, F) ≈ optcode(A, B, C, D, E, F)
true
```

## TensorOperations.jl

This optimizer will be used as an extension of [TensorOperations.jl](https://github.com/Jutho/TensorOperations.jl) in the future, see this [PR](https://github.com/Jutho/TensorOperations.jl/pull/185).
We compared the performance of this method against the default optimizer of TensorOperations.jl based on exhaustive searching, the results is shown below.

![](https://github.com/ArrogantGao/TreeWidthSolver_benchmark/blob/main/figs/compare_TO.png?raw=true)

The results shown that the tree width based solver is faster for some graph similar to trees.
For more details, please see the benchmark repo: [https://github.com/ArrogantGao/TreeWidthSolver_benchmark](https://github.com/ArrogantGao/TreeWidthSolver_benchmark).
